;;;-------------------------------------------------------------------------
;;; File BR        BR, GD, GT, TR, TT, PER Commands                 12/04/81
;;;-------------------------------------------------------------------------

;;;   ***T***   TRACE COMMAND

TCMD     DS      0              	; "T" Alias for "TR" command
TRCMD    LEA     TCMDHOT(PC),A0 	; IF NO PARAMTERS
         BSR     FNEXTF         	; FIND NEXT FIELD
         BSR     GETNUMA        	; FIND NUMBER OF INST TO TRACE
         BSR     CKADDR         	; INSURE 24 BITS OR LESS
         TST.L   D0
         BNE.S   TCMD15

TCMDHOT  DS      0              	; SPECIAL ENTRY FROM DECODE
         MOVEQ   #1,D0          	; ZERO; MAKE TRACE ONE
TCMD15   MOVE.L  D0,TRACECNT
         BRA.S   TRACE2


;;;
;;; ***TT*** "TRACE TILL" COMMAND
;;;

TTCMD    LEA     SYNTAX(PC),A0
         BSR     FNEXTF         	; FIND NEXT FIELD
         BSR     GETA           	; GET ADDRESS
         BSR     CKWADR         	; CHECK WORD BOUNDRY ADDRESS

         MOVE.L  D0,D6
         BSR     PPHY           	; DISPLAY TILL ADDRESS

         MOVE.L  D6,BPTILL      	; 9TH BP
         MOVE.L  #$FFFF,TRACECNT  	; SET FOR A VERY LONG TIME


TRACE2   MOVE.W  #-1,TRACEON    	; FOR DECODE OF NEXT COMMAND

         MOVE.L  REGPC,D0
         BSR     PPHY           	; DISPLAY START (PC) ADDRESS
         BRA     UNTRACE


;;;
;;;   ***GT***  RUN PROGRAM TO TEMP BREAKPOINT
;;;

GTCMD    LEA     SYNTAX(PC),A0  	; GET NUMBER ELSE PRINT "WHAT"
         BSR     FNEXTF         	; FIND NEXT FIELD
         BSR     GETA           	; GET ADDRESS
         BSR     CKWADR         	; CHECK WORD BOUNDRY ADDRESS
         MOVE.L  D0,D6          	; D6 = UNTIL ADDRESS
         BSR     PPHY           	; PRINT PHYSICAL ADDRESS

;;; IF TILL ADDRESS IN BREAKPOINT TABLE; DISPLAY WHAT

         LEA     BPADD,A0       	; A0 = POINTER TO BP ADDRESSES
         MOVEQ   #8,D7          	; D7 = # OF ADDRESS ALLOWED
GT21     CMP.L   (A0)+,D6
         BEQ     BCMD55         	; ALREADY IN TABLE -SHOW TABLE-
         SUBQ.L  #1,D7
         BNE     GT21

         MOVE.L  D6,BPTILL      	; 9TH BREAKPOINT
         BSR.S   GOCMD1A        	; NORMAL STARTUP
         BRA.S   GOCMD1

GOSET1   LEA     GOCMD1A(PC),A0 	; WHERE TO GO IF NO PARAMERS
         BSR     FNEXTF         	; FIND NEXT FIELD
         BSR     GETA           	; GET ADDRESS
         BSR     CKWADR         	; CHECK WORD BOUNDRY ADDRESS
         MOVE.L  D0,REGPC

GOCMD1A  MOVE.L  REGPC,D0       	; (ALSO SUBROUTINE ENTRY)
         BSR     PPHY           	; PRINT ".PC" PHYSICAL ADDRESS
         RTS

GCMD     DS      0              	; "G" ALIAS FOR "GO"
GOCMD    BSR     GOSET1         	; "GO" (AFTER TRACING ONE INST)
GOCMD1   MOVE.L  #-1,TRACECNT   	; "FLAG" COUNTER AS SPECIAL

         BRA     UNTRACE

GDCMD    BSR     GOSET1         	; "GO DIRECT" Command
         BRA     UNSTACK


;;;   ***BR***  SET AND PRINT BREAKPOINTS

;;;                   DELETE ALL BREAKPOINTS

NOBRCMD  BSR.S   FIXBP          	; GET POINTERS
BCMD01   CLR.L   (A0)+          	; CLEAR THE ADDRESS TABLE
         SUBQ.L  #1,D7          	; DO IT 8 TIMES
         BNE     BCMD01
         BRA.S   BCMD7          	; DISPLAY EMPTY TABLE

FIXBP    LEA     BPADD,A0       	; SET UP ADDRESS & COUNTER
         MOVEQ   #8,D7          	; COUNTER
         LEA     BPCNT,A2       	; COUNTS
         RTS

;;;***********************************************************
;;; THIS COMMAND SUPPORTS THE "NO" OPTION. COMMANDS THAT ALLOW
;;; THE "NO" OPTION PROVIDE A HARD BRANCH 4 BYTES BEFORE THE
;;; REGULAR COMMAND.
;;;***********************************************************

         BRA.L   NOBR0          	; ENTRY FOR "NOBR"
BRCMD    LEA     BCMD7(PC),A0   	; WHERE TO GO IF NO PARMS
BCMD0    BSR     FNEXTF         	; FIND NEXT FIELD
         BSR     GETA           	; GET ADDRESS
         BSR     CKWADR         	; CHECK WORD BOUNDRY ADDRESS

         BSR     FIXBP          	; SET UP COUNTER & ADDRESS
BCMD00   CMP.L   (A0),D0        	; SEE IF ALREADY IN TABLE
         BEQ.S   BCMD33         	; GO CHECK FOR COUNT
         ADDQ.L  #4,A2          	; BUMP OTHER POINTER
         ADDQ.L  #4,A0          	; BUMP MAIN POINTER
         SUBQ.L  #1,D7
         BNE     BCMD00

         BSR     FIXBP          	; GET ADDRESS & POINTERS
BCMD3    TST.L   (A0)           	; FIND AN EMPTY STOP
         BNE.S   BCMD5
         MOVE.L  D0,(A0)        	; PUT NEW ADDRESS IN TABLE
BCMD33   CLR.L   (A2)           	; CLEAR CURRENT COUNT
         MOVE.B  (A5),D1        	; CHECK INPUT FOR COUNT
         CMPI.B  #';',D1
         BNE.S   BCMD6          	; NO COUNT
         ADDQ.L  #1,A5          	; BUMP THE BUFFER SCANNER
         BSR     GETNUMA        	; GO GET THE COUNT
         MOVE.L  D0,(A2)        	; MOVE TO TABLE

BCMD6    LEA     BCMD7(PC),A0   	; WHERE TO GO IF NO MORE PARAMETERS
         BRA     BCMD0

BCMD5    ADDQ.L  #4,A0          	; BUMP TABLE POINTER
         ADDQ.L  #4,A2          	; BUMP POINTER TO COUNTS
         SUBQ.L  #1,D7          	; LOOP AROUND
         BNE     BCMD3

BCMD55   LEA     MSG008E(PC),A5 	; TABLE FULL; ERROR MESSAGE
         BSR     FIXDATA
         BRA.S   BCMD77

BCMD7    LEA     MSGBR(PC),A5   	; "BREAKPOINTS"
         BSR     FIXDCRLF
BCMD77   BSR     OUT1CR

         BSR     FIXBP          	; SET ADDRESS & COUNTER
BCMD8    MOVE.L  (A2)+,D6       	; D6 = COUNT
         MOVE.L  (A0),D0        	; D0 = ADDRESS
         BEQ.S   BCMD9          	; ZERO ADDRESS
         BSR     FRELADDR       	; FORMAT RELATIVE ADDRESS
         MOVE.B  #BLANK,(A6)+

         MOVE.L  (A0),D0        	; FORMAT ABSOLUTE ADDRESS
         BSR     PNT6HX
         MOVE.L  D6,D0
         BEQ.S   BCMD81         	; DON'T PRINT ZERO COUNT
         MOVE.B  #';',(A6)+
         BSR     PNTZHX         	; PRINT WITH ZERO SURPRESS

BCMD81   BSR     OUT1CR
BCMD9    ADDQ.L  #4,A0
         SUBQ.L  #1,D7          	; LOOP AROUND
         BNE     BCMD8
         BRA     MACSBUG

MSGBR    DC.B    'BREAKPOINTS',EOT



;;; NOBR COMMAND

NOBR0    LEA     NOBRCMD(PC),A0 	; WHERE TO GO IF NO PARAMETERS
NOBR1    BSR     FNEXTF         	; FIND NEXT FIELD
         BSR     GETA           	; GO DECODE NUMBER/ADDRESS
         TST.L   D0
         BEQ     BCMD55         	; ZERO NOT VALID BREAKPOINT
         BSR     CKWADR         	; CHECK WORD BOUNDRY ADDRESS

         LEA     BPADD,A0       	; SET UP TABLE POINTER
         MOVEQ   #8,D7          	; COUNTER
NOBR3    MOVE.L  (A0),D1        	; GET BREAKPOINT IN TABLE
         CMP.L   D1,D0          	; SEE IF SAME
         BEQ.S   NOBR4
         ADDQ.L  #4,A0
         SUBQ.L  #1,D7
         BNE     NOBR3
NOBR4    CLR.L   (A0)           	; CLEAR THIS BREAKPOINT
         LEA     BCMD7(PC),A0   	; WHERE TO GO IF NO PARAMETER
         BRA     NOBR1



