;;;-------------------------------------------------------------------------
;;; File DFDI      DF (Display registers) WITH disassembler         05/27/82
;;;-------------------------------------------------------------------------	

REGNAMES DC.L    'PCSR'         	; TABLE OF NAMES OF REGISTERS
         DC.L    'USSS'
         DC.W    '??'           	; END OF TABLE

DFCMD    DS      0              	; DF COMMAND  ENTRY
         BRA.S   TD07

TDISPLY  BSR     FIXBUF         	; PRINT TRACE DISPLAY SUBROUTINE
         ;TST.B   XONOFF+3
         ;BNE.S   TD25           	; SHORT DISPLAY

TD07     BSR     FIXBUF         	; PRINT PRELUDE
         CLR.L   OUTTO          	; FORCE DISPLAY TO OPERATORS CONSOLE
         MOVE.L  SCREEN1,(A6)+
         BEQ.S   TD09           	; SKIP PRELUDE
         BSR     OUTPUT
TD09

         LEA     REGNAMES(PC),A4 	; REGISTER NAMES
         LEA     REGPC,A2       	; REGISTER DATA
         BSR     FIXBUF         	; SET UP I/O BUFFER

TD1      MOVE.W  (A4)+,D0       	; GET REG NAME
         MOVE.L  (A2)+,D7       	; GET REG CONTENT
         CMPI.W  #'??',D0       	; SEE IF AT END OF REGS
         BNE.S   TD4
         BSR     OUT1CR         	; PRINT BUFFER

         MOVE.B  #'D',D7        	; CLASS=DATA
         LEA     REGS,A3        	; OFFSET
         BSR     PNTCLS         	; GO PRINT THE BLOCK

         MOVE.B  #'A',D7        	; CLASS=ADDRESS
         LEA     REGS+32,A3     	; OFFSET
         BSR     PNTCLS         	; GO PRINT THE BLOCK

         BSR     FIXBUF
         MOVEQ   #20,D1         	; LOOP COUNTER
TD27     MOVE.B  #'-',(A6)+     	; FILL BUFFER WITH BOARDER
         SUBQ.L  #1,D1
         BNE TD27

TD25     MOVE.L  REGPC,A4       	; DISASSEMBLE
         MOVEM.L (A4),D0-D2
         MOVE.L  A6,A5
         BSR     DCODE68K
         LEA     BUFFER,A5

         BSR     OUT1CR         	; PRINT

         BSR     FIXBUF         	; PRINT END STUFF FOR SCREEN CONTROL
         MOVE.L  SCREEN2,(A6)+
         BEQ.S   TD39           	; SKIP END STUFF
         BSR     OUTPUT
TD39     RTS     			; RETURN FOR MORE WORK

TD4      MOVE.W  D0,D2          	; PRINT REG NAME IN BUFFER
         ASR.W   #8,D0          	; MOVE IT OVER
         MOVE.B  D0,D3          	; SAVE REGISTER TYPE A,D,W,M ETC
         MOVE.B  D0,(A6)+       	; SAVE FIRST LETTER
         MOVE.B  D2,(A6)+       	; SAVE NEXT LETTER
         MOVE.B  #'=',(A6)+     	; EQUAL SIGN
         CMPI.W  #'US',D2
         BNE.S   T44
         MOVE.L  REGUS,D0       	; USER STACK
         BRA.S   T449

T44      CMPI.W  #'SS',D2       	; SUPER STACK IS SPECIAL
         BNE.S   T448
         MOVE.L  REGA7,D0       	; GET A7
         BRA.S   T449

T448     MOVE.L  D7,D0          	; REGISTER VALUE
         CMPI.W  #'SR',D2       	; SEE IF STATUS REGISTER
         BEQ.S   TDCC
T449     BSR     PNT8HX         	; FORMAT 8 HEX CHAR
TD9      MOVE.B  #BLANK,(A6)+   	; SPACE BETWEEN REGS
         BRA TD1

;;;   CONDITION CODE FORMAT
;;;
TDCC     MOVE.W  D0,D3          	; SAVE FOR A MOMENT
         BSR     PNT4HX
         MOVE.B  #'=',(A6)+
         MOVE.L  #$80000054,D7  	; TRACE BIT
         BSR.S   TDCC9
         MOVE.L  #$20000053,D7  	; SUPERVISOR BIT
         BSR.S   TDCC9
         MOVE.W  D3,D0          	; INTERRUPT LEVEL
         LSR.W   #8,D0
         ANDI.B  #$07,D0        	; "7" MAX IN SR FOR LEVEL
         BSR     PUTHEX
         MOVE.L  #$100058,D7    	; X BIT
         BSR.S   TDCC9
         MOVE.L  #$8004E,D7     	; N BIT
         BSR.S   TDCC9
         MOVE.L  #$4005A,D7     	; Z BIT
         BSR.S   TDCC9
         MOVE.L  #$20056,D7     	; V BIT
         BSR.S   TDCC9
         MOVE.L  #$10043,D7     	; C BIT
         BSR.S   TDCC9
         BRA     TD9

TDCC9    MOVE.L  D7,D6          	; DUPLICATE STUFF
         SWAP    D6             	; GET BIT POSITION
         AND.W   D3,D6          	; SEE IF ON
         BNE.S   TDCC91
         MOVE.B  #'.',D7        	; PUT IN PERIOD IF OFF
TDCC91   MOVE.B  D7,(A6)+       	; PUT IN LETTER IF ON
         RTS


