;;;
;;; Fred's monitor, base on Motorola's tutor board code.
;;;

	INCLUDE "defs.asm"		; various defines
	INCLUDE "aram.asm"		; data variables
	INCLUDE "b.asm"			; init vectors+ram
	INCLUDE "e.asm"			; monitor entry point
	INCLUDE "commands.asm"		; command list
	INCLUDE "vectmsg.asm"		; messages for vectors
	INCLUDE "bf.asm"		; BF (Block Fill) command
	INCLUDE "bm.asm"		; BM (Block Move) command
	INCLUDE "br.asm"	  	; BR, GD, GT, TR, TT commands
	INCLUDE "bs.asm"		; BS (Block Search) command
	INCLUDE "bt.asm"		; BT (Block Test) command
	INCLUDE "dc.asm"	  	; DC (data conversion) command
	INCLUDE "dfdi.asm"	  	; DF (display reg) with disassembler
	INCLUDE "dump.asm"		; DU (dump S-Record) command
	INCLUDE "geta.asm"	  	; get address subroutine
	INCLUDE "h.asm"			; register save, trace, breakpoint
	INCLUDE "he.asm"		; HE (help) command
	INCLUDE "hex2dec.asm"		; convert hex to decimal
	INCLUDE "load.asm"		; LO (load S-Record) command
	INCLUDE "mddi.asm"	  	; MD[S] (Memory Display) command
	INCLUDE "mmdi.asm"		; MM (Modify Memory) command
	INCLUDE "ms.asm"	  	; MS (Memory set) command
	INCLUDE "mtsetup.asm"		; memory test setup routine
	INCLUDE "of.asm"	  	; OF and PERIOD commands
	INCLUDE "flash.asm"		; FLASH utilities
	INCLUDE "time.asm"		; DA (Date), TI (Time) commands
	;; pf
	INCLUDE "ramtest.asm"	  	; ramtest routine
	;; tm
	INCLUDE "w.asm"			; software abort, hex print routines
	INCLUDE "x.asm"			; common I/O
	INCLUDE "y.asm"			; I/O routines
	INCLUDE "code68k.asm"		; 68K one line assembler
	INCLUDE "dcode68k.asm"		; 68K one line disassembler
	INCLUDE "crc32.asm"		; CRC32 routines and CR command
	INCLUDE "trap14.asm"		; TRAP #14 handler
	
	;; Fred's additions
	INCLUDE "uart.asm"
	INCLUDE "delay.asm"		
	INCLUDE "lcd.asm"
	;INCLUDE "ay8910.asm"		; basic command interface to AY-3-8910

	INCLUDE "zmodem.asm"
	INCLUDE "crc_table.asm"

LAST	DS.W	0
	