;;;-------------------------------------------------------------------------
;;; File MDDI      MD[S] (Memory Display) Command                   06/16/82
;;; 
;;;   ***MD***   MEMORY DISPLAY         ENTRY POINT
;;;     FORMAT:  MD[S] <ADDRESS> [<COUNT>] [;DI]
;;; 1.  IF 'S' USED IN COMMAND THEN IT WILL DUMP 16 LINES, (1 Screen), AND
;;;     PROMPT-ENTER CR FOR 16 MORE LINES ETC OR ANY MACSBUG COMMAND.
;;;-------------------------------------------------------------------------

MDCMD    DS      0
         BSR     SCANPORT       	; WHERE TO SEND OUTPUT
         MOVE.L  INPORT1,INFROM 	; ONLY ALLOW INPUT FROM PORT1

         MOVEQ   #-1,D6         	; D6 = HOW MANY LINES PER PAGE

         SUB.L   A3,A3          	; A4 = DEFAULT ZERO  START
         MOVE.L  A3,A4          	; A3 = END ADDR

         CLR.L   D7             	; D7 = DO NOT DISASSEMBLE
         MOVE.L  A5,A2
PRINT8   CMP.L   A2,A6          	; LOOK FOR OPTIONS
         BCS.S   PRINTDI        	; NO  OPTIONS
         CMPI.B  #';',(A2)+
         BNE     PRINT8

         MOVE.L  A2,A6
         SUBQ.L  #1,A6          	; A6 = POINTER TO ;

         CMPI.B  #'D',(A2)+
PRINTMB  BNE     SYNTAX         	; COMMAND SYNTAX ERROR
         CMPI.B  #'I',(A2)+
         BNE     PRINTMB
         MOVEQ   #-1,D7         	; DISASSEMBLE OPTION
PRINTDI


;;; LOOK FOR "S" IN COMMAND
         MOVE.B  (A5),D0
         CMPI.B  #'S',D0
         BNE.S   PRINT5         	; NO "S" IN COMMAND
         ADDQ.L  #1,A5          	; MOVE PAST "S"

         MOVEQ   #16,D6         	; DO 16 LINES AT A TIME
         SUB.L   A3,A3
         SUBQ.L  #1,A3          	; MAX END ADDRESS

PRINT5   LEA     PRINT7(PC),A0  	; WHERE TO GO IF NO PARAMETERS
         BSR     FNEXTF         	; FIND NEXT FIELD
         BSR     GETA
         MOVE.L  D0,A4          	; A4 = GET ADDRESS

         BSR     FNEXTF
         BSR     GETEXP         	; D0 = GET COUNT
         ADD.L   A4,D0          	; END=START+COUNT-1
         SUBQ.L  #1,D0          	; BACK OFF ONE
         MOVE.L  D0,A3          	; A3 = END ADDRESS

PRINT7   TST.L   D7
         BEQ.S   PUTADR         	; NOT DISASSEMBLE

PRINTDI5 BSR     FIXBUF         	; DI OPTION
         MOVEM.L A3/D6-D7,-(A7)
         MOVEM.L (A4),D0-D2     	; D0-D2 = DATA TO DISASSEMBLE
         BSR     DCODE68K       	; DISASSEMBLE
         BSR     OUT1CR
         MOVEM.L (A7)+,A3/D6-D7

         SUBQ.L  #1,D6
         BEQ.S   PRINT9         	; 'MDS' COMMAND

         CMP.L   A4,A3          	; END CHECK
         BCC     PRINTDI5
         BRA.S   PRINT9

PRINT3   MOVEQ   #16,D6         	; D6 = LINE BLOCK COUNT
         SUB.L   A3,A3
         SUBQ.L  #1,A3          	; A3 = MAX END ADDRESS
         BRA     PRINT7

;;; START A NEW  LINE
;;;
PUTADR   BSR     FIXBUF         	; SET UP OUTPUT BUFFER
         MOVE.L  A4,D0          	; CURRENT LINE ADDRESS
         BSR     FRELADDR       	; FORM RELATIVE ADDRESS
         MOVE.B  #$20,(A6)+     	; FORMAT  SPACE
         MOVE.L  A4,A0          	; A0 IS SCANNING ADDRESS
         MOVEQ   #$10,D3        	; SET UP COUNTER FOR LOOP

NXTBP    MOVE.B  (A0)+,D0       	; GET BYTE TO PRINT
         BSR     PNT2HX         	; PRINT IT
         MOVE.B  #$20,(A6)+     	; SPACE BETWEEN EACH HEX

         CMPI.B  #9,D3          	; HALF LINE SPACING
         BNE.S   NXTBP3
         MOVE.B  #$20,(A6)+
NXTBP3

         SUBQ.L  #1,D3
         BNE     NXTBP          	; LOOP TILL D3 IS ZERO

         MOVE.B  #$20,(A6)+     	; MOVE A SPACE
         MOVE.L  A4,A0          	; RELOAD SCANNER FOR ASCII PRINTS
         MOVEQ   #$10,D3        	; RELOAD COUNTER

NXTCHR   MOVE.B  (A0)+,D0       	; FETCH BYTE
         ANDI.B  #$7F,D0        	; REMOVE HIGH ORDER BIT,
					;   (ASCII ONLY USES 7 BITS)	
         CMPI.B  #$20,D0        	; SEE IF IT IS CONTROL CHAR
         BLT.S   NOTCHR         	; BYPASS IF IT IS... ELSE
         CMPI.B  #$7F,D0        	; IS IT A "7F"?
					;   (CAUSES PRINTER PROBLEM)
         BLT.S   PUTCHR         	; NO. THEN PRINT IT, ELSE SUBSTITUTE "."
NOTCHR   MOVE.B  #'.',D0        	; CHANGE UNPRINTABLE TO PERIOD

PUTCHR   MOVE.B  D0,(A6)+       	; MOVE "EDITTED" CHARACTER TO PRINT LINE
         SUBQ.L  #1,D3          	; LOOP AROUND FOR NEXT CHAR
         BNE     NXTCHR         	; ANY LEFT?
         BSR     OUT1CR         	; NO... THEN PRINT THE COMPLETE LINE
         ADDQ.L  #$08,A4        	; UPDATE STARTING ADDRESS OF NEXT ADDR
         ADDQ.L  #$08,A4        	; ........
         CMP.L   A4,A3          	; DOES NEW LINE START PAST END
         BCS.S   PRINT9         	; SEE IF STILL GOING
         SUBQ.L  #1,D6          	; DECR THE COUNTER
         BNE     PUTADR         	; DO ANOTHER LINE

PRINT9   LEA     MSG001(PC),A5  	; SET UP FOR PROMPT
         BSR     FIXDATA
         MOVE.B  #'>',(A6)+     	; PROMPT SAME AS MACSBUG
         MOVE.B  #BLANK,(A6)+
         BSR     OUTPUT         	; PRINT IT

         BSR     FIXBUF         	; RESET BUFFER
         BSR     PORTIN1        	; TAKE IN INPUT
         CMP.L   A6,A5          	; SEE IF ANYTHING ENTERED
         BEQ     PRINT3         	; NOTHING ENTERED; DO 16 MORE LINES
         CLR.L   OUTTO          	; *
         BRA     DECODE6        	; GO MAKE SURE 2ND DIGIT IS BLANK


